<template>
    <div class="edit-view">
        <page-title>
            <el-button @click="$router.go(-1)" :disabled="saving">取消</el-button>
            <el-button @click="onDelete" :disabled="saving" type="danger" v-if="formData.id">
                删除
            </el-button>
            <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
        </page-title>
        <div class="edit-view__content-wrapper">
            <div class="edit-view__content-section">
                <el-form
                    :model="formData"
                    :rules="rules"
                    ref="form"
                    label-width="140px"
                    label-position="right"
                    size="small"
                    style="max-width: 600px;"
                >
                    <el-form-item prop="name" label="机构名称">
                        <el-input v-model="formData.name"></el-input>
                    </el-form-item>
                    <el-form-item prop="nature" label="机构性质">
                        <el-radio-group v-model="formData.nature">
                            <el-radio v-for="item in natureOptions" :key="item.value" :label="item.value">
                                {{ item.label }}
                            </el-radio>
                        </el-radio-group>
                    </el-form-item>
                    <el-form-item prop="establishedAt" label="成立日期">
                        <el-date-picker
                            v-model="formData.establishedAt"
                            type="date"
                            value-format="yyyy-MM-dd"
                            placeholder="选择日期"
                        >
                        </el-date-picker>
                    </el-form-item>
                    <el-form-item prop="logo" label="logo">
                        <single-upload v-model="formData.logo"></single-upload>
                    </el-form-item>
                    <el-form-item prop="url" label="官网地址">
                        <el-input v-model="formData.url"></el-input>
                    </el-form-item>
                    <el-form-item prop="introduction" label="机构简介">
                        <el-input type="textarea" v-model="formData.introduction"></el-input>
                    </el-form-item>
                    <el-form-item prop="uscc" label="统一社会信用代码 ">
                        <el-input v-model="formData.uscc"></el-input>
                    </el-form-item>
                    <el-form-item prop="businessLicense" label="营业执照">
                        <single-upload v-model="formData.businessLicense"></single-upload>
                    </el-form-item>
                    <el-form-item prop="nickname" label="姓名">
                        <el-input v-model="user.nickname"></el-input>
                    </el-form-item>
                    <el-form-item prop="phone" label="电话">
                        <el-input v-model="user.phone"></el-input>
                    </el-form-item>
                    <el-form-item prop="email" label="邮箱">
                        <el-input v-model="user.email"></el-input>
                    </el-form-item>
                    <el-form-item class="form-submit">
                        <el-button @click="onSave" :loading="saving" type="primary">
                            保存
                        </el-button>
                        <el-button @click="onDelete" :disabled="saving" type="danger" v-if="formData.id">
                            删除
                        </el-button>
                        <el-button @click="$router.go(-1)" :disabled="saving">取消</el-button>
                    </el-form-item>
                </el-form>
            </div>
        </div>
    </div>
</template>
<script>
export default {
    name: 'InstitutionEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('institution/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                    this.$http
                        .get('user/get/' + res.userId)
                        .then(user => {
                            this.user = user;
                        })
                        .catch(e => {
                            console.log(e);
                            this.$message.error(e.error);
                        });
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                name: { required: true, message: '请输入单位名称', trigger: 'blur' },
                nature: { required: true, message: '请输入机构性质', trigger: 'blur' },
                phone: { required: true, message: '请输入您的联系方式', trigger: 'blur' },
                email: { type: 'email', required: true, message: '请输入您的邮箱', trigger: 'blur' },
                introduction: { required: true, message: '请填写对接描述', trigger: 'blur' },
                businessLicense: { required: true, message: '请添加营业执照', trigger: 'blur' },
                logo: { required: true, message: '请添加企业logo', trigger: 'blur' },
                uscc: { required: true, min: 18, max: 18, message: '请输入18位统一社会信用代码', trigger: 'blur' },
                nickname: { required: true, message: '请输入您的真实姓名', trigger: 'blur' }
            },
            user: {},
            natureOptions: [
                { label: '军工单位', value: 'MILITARY_INDUSTRY' },
                { label: '民口企业', value: 'MINKOU' },
                { label: '民营企业', value: 'PRIVATE' },
                { label: '其他', value: 'OTHER' }
            ]
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };
            let data1 = { ...this.user };
            this.saving = true;
            this.$http
                .post('/institution/save', data, { body: 'json' })
                .then(res => {
                    this.$http
                        .post('/user/save', data1, { body: 'json' })
                        .then(res => {
                            this.saving = false;
                            this.$message.success('成功');
                            this.$router.go(-1);
                        })
                        .catch(e => {
                            console.log(e);
                            this.saving = false;
                            this.$message.error(e.error);
                        });
                    // this.saving = false;
                    // this.$message.success('成功');
                    // this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/institution/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error((e || {}).error || '删除失败');
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
